import random
import time
import matplotlib.pyplot as plt
from statistics import mean

def max_simple(L):
	if len(L) == 0:
		return
	m = L[0]
	for i in range(1, len(L)):
		e = L[i]
		if e > m:
			m = e
	return m

def max_divise_regner(L):
	n = len(L)
	if n == 0:
		return
	if n == 1:
		return L[0]
	m1 = max_divise_regner(L[:n//2])
	m2 = max_divise_regner(L[n//2:])
	return max(m1, m2)

def max_divise_regner2_aux(L, a, b):
	if (b - a) == 1:
		return L[a]
	point_median = a + (b - a)//2
	m1 = max_divise_regner2_aux(L, a, point_median)
	m2 = max_divise_regner2_aux(L, point_median, b)
	return max(m1, m2)

def max_divise_regner2(L):
	if len(L) == 0:
		return
	return max_divise_regner2_aux(L, 0, len(L))

if __name__ == "__main__":
	fcts = [max_simple, max_divise_regner, max_divise_regner2]
	plt.xlabel("Taille de la liste")
	plt.title("Temps d'exécution des fonctions maxs")

	points = 50
	degree = 2
	repetition = 40
	fig, axs = plt.subplots(1, len(fcts), constrained_layout=True)

	for i, f in enumerate(fcts):
		resultats = []
		ax = axs[i]
		for i in range(1, points):
			i = i**degree
			L = list(range(i))
			temps_calculs = []
			resultats.append(temps_calculs)
			for _ in range(repetition):
				init_time = time.time_ns()
				_ = f(L)
				stop_time = time.time_ns()
				temps_calculs.append(stop_time - init_time)

		ax.plot(
			[(i**degree) for i in range(1, points)],
			[mean(x)/10**3 for x in  resultats],
			marker=".",
			label=f.__name__
			)
		ax.set_ylabel("Temps (en µs)")
		ax.set_xlabel("Taille de la liste")
		ax.legend()
	plt.savefig("maxs.png")
